------------------------------------------------------------------------------------------
-- Main file
-- Written by Homeopatix
-- 7 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Import Lotro librarys --
------------------------------------------------------------------------------------------
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";
import "Turbine.Gameplay";
import "Turbine.Gameplay.Attributes";
------------------------------------------------------------------------------------------
-- Import Globals --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.Globals";
------------------------------------------------------------------------------------------
-- Import Utility --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.VindarPatch";
import "Homeopatix.HorseStable.Notification";
import "Homeopatix.HorseStable.LoadAndSave";
import "Homeopatix.HorseStable.MinimizedIcon";
import "Homeopatix.HorseStable.FCT";
------------------------------------------------------------------------------------------
-- Import initialization --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.Init";
import "Homeopatix.HorseStable.Activation";
------------------------------------------------------------------------------------------
-- Import Scripts --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.Main";
------------------------------------------------------------------------------------------
-- Import UI elements --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.UI";
import "Homeopatix.HorseStable.OptionsWindow";
------------------------------------------------------------------------------------------
-- Import Commands --
------------------------------------------------------------------------------------------
import "Homeopatix.HorseStable.Commands";
------------------------------------------------------------------------------------------
-- create the localization texte
------------------------------------------------------------------------------------------
CreateLocalizationInfo();
------------------------------------------------------------------------------------------
-- create the window
------------------------------------------------------------------------------------------
GenerateWindow();
------------------------------------------------------------------------------------------
-- create the options window
------------------------------------------------------------------------------------------
GenerateOptionsWindow();
------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
CreateAndHandleMinimizeIcon();
------------------------------------------------------------------------------------------
-- event handling for escape key
------------------------------------------------------------------------------------------
EscapeKeyPressed();
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
WindowPositionChanged();
------------------------------------------------------------------------------------------
-- if the position changes, save the new option window location
------------------------------------------------------------------------------------------
OptionsWindowPositionChanged();